import Sale from "../sales/models/Sale";
import Product from "../products/models/Product";
import User from "../users/models/User";
import CartProduct from "./CartProduct";
declare class SaleItems {
    sale?: Sale;
    items?: CartProduct[];
    clientId?: number;
    isWaiting?: boolean;
    inCredit?: boolean;
}
export default class HlpShop {
    private httpService;
    constructor(httpService: any);
    isProductInCart(item: CartProduct, product: Product): true;
    addToCart: (cartProducts: CartProduct[], product: Product, qtity: number) => Promise<CartProduct[]>;
    removeItem: (cartProducts: CartProduct[], product: Product) => void;
    removeFromCart: (cartProducts: CartProduct[], item: CartProduct) => void;
    getTotalAmount: (cartProducts: CartProduct[], client: User) => number;
    getTotalAmountAllIncluded: (cartProducts: CartProduct[], client: User, shippingFee?: number, otherFee?: number, discount?: number) => number;
    getTotalAmountDiscount: (cartProducts: CartProduct[], client: User, discountRate: number) => number;
    getTotalQtityFree: (cartProducts: CartProduct[]) => number;
    getTotalQtityReal: (cartProducts: CartProduct[]) => number;
    getTotalAmountWithoutTva: (cartProducts: CartProduct[], client: User) => number;
    getTotalTva: (cartProducts: CartProduct[], client: User) => number;
    updateCartQtity: (cartProducts: CartProduct[], product: Product, qtity: number) => Promise<CartProduct[]>;
    addDiscount(cartProducts: CartProduct[], item: CartProduct): void;
    convertToSale(cartProducts: CartProduct[], sale: Sale): void;
    removeAllFromCart(cartProducts: CartProduct[]): void;
    checkout(cartProducts: CartProduct[], inCredit?: boolean): Promise<any>;
    getSaleItems(): SaleItems;
    private createCart;
    calculateStockOrQtityLimitCounts: (item: CartProduct) => CartProduct | boolean;
    getPublicPrice: (product: Product, client: User, specialPrice?: number, addDiscount?: boolean) => number;
}
export {};
