"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const hlpProduct_1 = __importDefault(require("../products/hlpProduct"));
class SaleItems {
}
class HlpShop {
    constructor(httpService) {
        this.addToCart = (cartProducts, product, qtity) => __awaiter(this, void 0, void 0, function* () {
            let nCartProducts = [];
            this.createCart(product.shop.id);
            const nItem = cartProducts.find((item) => this.isProductInCart(item, product));
            if (!nItem) {
                nCartProducts = [...cartProducts, { product, qtityOdr: 1 }];
            }
            else {
                nCartProducts = yield this.updateCartQtity(cartProducts, product, qtity);
            }
            sessionStorage.setItem("basket", JSON.stringify(nCartProducts));
            return nCartProducts;
        });
        this.removeItem = (cartProducts, product) => {
            cartProducts.find((item, index) => {
                if (item.product.id === product.id) {
                    const item = cartProducts[index];
                    this.removeFromCart(cartProducts, item);
                }
                return false;
            });
        };
        // ------ Removed in cart ------
        this.removeFromCart = (cartProducts, item) => {
            const index = cartProducts.indexOf(item);
            cartProducts.splice(index, 1);
            sessionStorage.setItem("basket", JSON.stringify(cartProducts));
        };
        // --------------------
        this.getTotalAmount = (cartProducts, client) => {
            return cartProducts.reduce((prev, curr) => {
                return Math.ceil(prev /* (this.publicPriceBy(curr.product, client, curr.speUnitPrice, curr.addDiscount) * curr.product.tva) / 100) * curr.qtityOdr + */ +
                    this.getPublicPrice(curr.product, client, curr.specialPrice, curr.addDiscount) * curr.qtityOdr);
            }, 0);
        };
        // ------ getTotalAmountAllIncluded ------
        this.getTotalAmountAllIncluded = (cartProducts, client, shippingFee = 0, otherFee = 0, discount = 0) => {
            return Math.ceil(this.getTotalAmount(cartProducts, client) + shippingFee + otherFee + -this.getTotalAmountDiscount(cartProducts, client, discount));
        };
        this.getTotalAmountDiscount = (cartProducts, client, discountRate) => {
            return Math.ceil((+this.getTotalAmount(cartProducts, client) * discountRate) / 100);
        };
        // ------ total quantity free------
        this.getTotalQtityFree = (cartProducts) => {
            return cartProducts.reduce((prev, curr) => {
                return prev + (+curr.qtityFree || 0);
            }, 0);
        };
        // ------ total quantity  ------
        this.getTotalQtityReal = (cartProducts) => {
            return cartProducts.reduce((prev, curr) => {
                return prev + (curr.qtityOdr + (curr.qtityFree || 0));
            }, 0);
        };
        // ------ Total sub amount ------
        this.getTotalAmountWithoutTva = (cartProducts, client) => {
            return cartProducts.reduce((prev, curr) => {
                return Math.ceil(prev + this.getPublicPrice(curr.product, client, curr.specialPrice, curr.addDiscount) * curr.qtityOdr);
            }, 0);
        };
        // ------ Total tva ------
        this.getTotalTva = (cartProducts, client) => {
            return 0;
            /* return cartProducts.reduce((prev: number, curr: CartProduct) => {
              return Math.ceil(
                prev +
                  this.unitPriceByClientCatInPhcy(curr.product, client, curr.speUnitPrice, curr.addDiscount) *
                    (+curr.product.tva / 100) *
                    curr.qtityOdr
              );
            }, 0); */
        };
        // ------ Update Cart Value ------
        this.updateCartQtity = (cartProducts, product, qtity) => __awaiter(this, void 0, void 0, function* () {
            const index = cartProducts.findIndex((item) => this.isProductInCart(item, product));
            cartProducts[index].qtityOdr = qtity;
            const qtyInCart = +cartProducts[index].qtityOdr;
            const stock = this.calculateStockOrQtityLimitCounts(cartProducts[index]);
            // --------------------
            if (qtyInCart > 0 && stock) {
                cartProducts[index].qtityOdr = qtyInCart;
            }
            sessionStorage.setItem("basket", JSON.stringify(cartProducts));
            return cartProducts;
        });
        this.createCart = (shopId) => __awaiter(this, void 0, void 0, function* () {
            if (!sessionStorage.getItem("sale")) {
                try {
                    const { data: sale } = yield this.httpService.postBody({ shopId }, "shops/sale");
                    if (sale) {
                        sessionStorage.setItem("sale", JSON.stringify(sale));
                    }
                }
                catch (error) {
                    // Toastify.error();
                }
            }
        });
        // ------ Calculate Product stock Counts ------
        // calculateStockOrQtityLimitCounts = (item: CartProduct, qtity: number): CartProduct | boolean => {
        this.calculateStockOrQtityLimitCounts = (item) => {
            // const qty = +item.qtityOdr + +qtity;
            const qty = +item.qtityOdr;
            const stockSalable = +hlpProduct_1.default.getStockSalable(item.product);
            if (stockSalable < qty) {
                item.qtityOdr = stockSalable;
                return false;
            }
            return true;
        };
        // --------------------
        this.getPublicPrice = (product, client, specialPrice = 0, addDiscount = false) => {
            if (specialPrice > 0) {
                return specialPrice;
            }
            // const store = await getCustomRepository(ProductStoreRepository).getOneStoreByParams({storeName: 'cpa', productId: product.id})
            // if (product.discountRate && addDiscount) {
            //   return Math.ceil(product.publicPrice) - Math.ceil(calculPercent(product.publicPrice, product.discountRate));
            // }
            return Math.ceil(product.price);
        };
        this.httpService = httpService;
    }
    isProductInCart(item, product) {
        return item.product.id === product.id || null;
    }
    addDiscount(cartProducts, item) {
        item.addDiscount = !item.addDiscount;
        sessionStorage.setItem("basket", JSON.stringify(cartProducts));
    }
    convertToSale(cartProducts, sale) {
        const items = sale.saleProducts;
        const client = sale.client;
        for (const item of items) {
            // this.updateCartQtity(cartProducts, item.product, item.qtityOdr);
        }
        sessionStorage.setItem("client", JSON.stringify(client));
        // sale = deepClone(sale);
        delete sale.saleProducts;
        delete sale.client;
        // --------------------
        if (sale.isProforma) {
            sale.proformaToSale = true;
            sale.isValided = true;
            sale.isProforma = false;
        }
        else if (sale.isWaiting) {
            sale.waitingToSale = true;
            sale.isWaiting = false;
            sale.isValided = true;
        }
        // --------------------
        sessionStorage.setItem("sale", JSON.stringify(sale));
        // --------------------
    }
    // removeAllFromCart(cartProducts: CartProduct[]) {
    removeAllFromCart(cartProducts) {
        cartProducts.splice(0, cartProducts.length);
        sessionStorage.removeItem("basket");
        sessionStorage.removeItem("client");
        sessionStorage.removeItem("sale");
    }
    checkout(cartProducts, inCredit) {
        return __awaiter(this, void 0, void 0, function* () {
            const saleItems = this.getSaleItems();
            try {
                if (inCredit) {
                    saleItems.inCredit = true;
                }
                // const { data } = await httpService.create(saleItems, "checkout");
                // if (data) {
                // this.removeAllFromCart(cartProducts);
                // queryClient.invalidateQueries({ queryKey: ["pos_products"] });
                // Toastify.success("commande bien enégistrée");
                // return data;
                return this.httpService.create(saleItems, "checkout");
                // }
            }
            catch (error) { }
        });
    }
    getSaleItems() {
        let saleItems = new SaleItems();
        saleItems.sale = JSON.parse(sessionStorage.getItem("sale"));
        saleItems.items = JSON.parse(sessionStorage.getItem("basket"));
        saleItems.clientId = sessionStorage.getItem("client") ? JSON.parse(sessionStorage.getItem("client")).id : null;
        return saleItems;
    }
}
exports.default = HlpShop;
